<?php
/* Autoindex directories.
   Copyright (C) 2005, 2006 David Englund.

This file is part of GNU Sovix.

GNU Sovix is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Sovix is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Sovix; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
Boston, MA 02110-1301, USA.  */
?>


<form action='/sovix/include/redirect' method='post'>
<ins>
<!--
* Maxdept 1
* Sort by directory
* Specify many paths

Example: list all .php/.inc files in the root of /var/www/ but not in the subdirectories
and at the same time list all .php/.inc files /var/www/test/ and its subdirectories.

-->

<select name="file" OnChange="location=getSelect(this)" style="font-size: 9pt; width:90%;" >

<?php
require $_SERVER['DOCUMENT_ROOT'] . $infopath . '/autoindex-data.inc';
function walk_dir($array,$level) {
  $pad = "  ";
  foreach ($array as $name=>$content) {
    //echo str_pad("",$level,$pad,STR_PAD_LEFT);

    $search = array("/", "_", ".php");
    $output_replace  = array(" / ", " ", "");
    $dir=str_replace($_SERVER['DOCUMENT_ROOT'] ."/", "", $content['PATHNAME']);
    $out_dir=str_replace($search, $output_replace, $dir);
    $file=str_replace($_SERVER['DOCUMENT_ROOT'] ."/", "", $content);
    $out_file=str_replace($search, $output_replace, $file);
    $just_file=str_replace($search, $output_replace, $file);

    if (is_array($content)) {
      echo "<option value=\"/".$dir."\">/ ".$out_dir."/</option>\n";
      unset($content['PATHNAME']);
      walk_dir($content,$level+1);
    }
    else {
      echo "<option value=\"/".str_replace(".php", "", $file)."\"";
      /* Select */
      if ($_SERVER['SCRIPT_FILENAME']=="$content") echo " selected=\"selected\"";
       echo ">";

       /*
  This works but the directories must be sorted _after_ the files so the content does not get mixed.
  $countslash = count(explode("/","$out_file"))-1;
  $i=1; while ($i <= $countslash) { echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; $i++; }; echo str_replace("_", " ", basename($out_file));
       */

  echo "/ $out_file";
      echo "</option>\n";
    }
  }
}

function build_dir($path,$extensions,$ignore_files,$ignore_subdirectories) {
  $result = array();
  $d = dir($path);
  while(false !== $entry = $d->read()) {	
    if (in_array($entry,$ignore_files)) {
      continue;
    }
    $extpos = strrpos($entry,".");
    $file = substr($entry,0,$extpos);
    $ext = substr($entry,$extpos+1);
    if ($ignore_subdirectories=="n" && is_dir($path."/".$entry)) {
      if (substr($entry,0,1) == ".") {
	continue;
      }
      $res = build_dir($path."/".$entry,$extensions,$ignore_files,$ignore_subdirectories);
      if (count($res) > 0) {
	$res['PATHNAME'] = $path."/".$entry;
	$result[$entry] = $res;
      }
    } else if (in_array($ext,$extensions)) {
      $result[$entry] = $path."/".$entry;
    }

  }
  ksort($result);
  return $result;
}

?>


</select>
<input type="submit" value="Go" style="border-style:inherit; background-color:#efefef;" />
</ins>
</form>
